/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.ejb.local;

import java.util.List;
import java.util.Map;

/**
 *
 * @author sebastien.glon
 */
public interface MailManagerLocal {

    /**
     * Méthode d'envoi d'email.
     * @param subject
     * @param content
     * @param address
     */
    void sendMail(final String subject, final String content, final String address);

    /**
     * Méthode d'envoi d'email à partir d'un tempate à un seul destinataire.
     * @param userId userName de l'utilisateur destinataires du mail.
     * @param TemplateKey clé du tmplate à utiliser.
     * @param properties propriete à intégrer dans le mail.
     */
    void sendEmailWithTemplate(final String userName, final String TemplateKey, Map<String, Object> properties);

    /**
     * Méthode d'envoi d'email à partir d'un tempate à une liste de destinataire.
     * @param usersName userName des utilisateurs destinataires du mail.
     * @param TemplateKey clé du tmplate à utiliser.
     * @param properties propriete à intégrer dans le mail.
     */
    void sendEmailWithTemplate(final List<String> usersName, final String TemplateKey, Map<String, Object> properties);
}
