/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.ejb.local;

import com.evasion.entity.security.Group;
import com.evasion.entity.security.User;
import com.evasion.exception.PersistenceViolationException;
import java.util.Date;
import java.util.List;
import org.springframework.security.annotation.Secured;

/**
 *
 * @author sebastien.glon
 */
public interface UserAuthServiceLocal {

    /* Interface pour la gestion des utilisateurs */
    List<User> listUsers();

    @Secured("IS_AUTHENTICATED_ANONYMOUSLY")
    User createUser(User u) throws PersistenceViolationException;

    User findUserByUserName(String u);

    void deleteUser(User u);

    User updateUser(User u);

    /**
     * Récupération de la date de dernière connection  d'un utilisateur.
     * @param login nom d'utilisateur.
     * @return date de dernière connection.
     */
    Date lastLoginForUser(String login);

    /* Interface pour la gestion des groupes */
    List<Group> listGroups();

    /**
     * Met à jour la date de dernière connection.
     * @param userName nom d'utilisateur.
     */
    void updateLastLogin(String userName);
}
