/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.entity.security;

import com.evasion.entity.security.User;
import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

/**
 * create table persistent_logins (
 *username varchar(64) not null,
 *series varchar(64) primary key,
 *token varchar(64) not null,
 *last_used timestamp not null);
 * @author sebastien.glon
 */
@Entity
public class Persistentlogin implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @Column(nullable = false, length = 64)
    private String series;

    @OneToOne
    @JoinColumn(name = "username", nullable=false)
    private User user;

    @Column(nullable = false, length = 64)
    private String token;

    @Column(nullable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Calendar lastUsed = new GregorianCalendar();

    /**
     * Constructeur utilise pour la persistence.
     */
    protected Persistentlogin() {
    }

    /**
     * Constructeur avec les champs obligatoires.
     * @param user utilisateur.
     */
    public Persistentlogin(User user) {
        this.user = user;
    }



    public Date getLastUsed() {
        return lastUsed.getTime();
    }

    public void setLastUsed(Date last_used) {
        Calendar calendar = new GregorianCalendar();
        calendar.setTime(last_used);
        this.lastUsed = calendar;
    }

    public String getSeries() {
        return series;
    }

    public void setSeries(String series) {
        this.series = series;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    /**
     * {@inheritDoc }
     */
    @Override
    public boolean equals(final Object obj) {
        if (obj == null) {
            return false;
        }
        if (this == obj) {
            return true;
        }
        if (!( obj instanceof Persistentlogin )) {
            return false;
        }
        Persistentlogin rhs = (Persistentlogin) obj;

        return new EqualsBuilder().append(this.user, rhs.user).isEquals();
    }

    /**
     * @{@inheritDoc }
     */
    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37).append(this.user).toHashCode();
    }


    @Override
    public String toString() {
        return "com.evasion.plugin.security.Persistent_logins[series=" + series
                + " user=" + user
                + " token=" + token
                + " last_used=" + lastUsed
                + "]";
    }

}
